modules/adhocproject/controllers/LeadController.php
<?php

namespace app\modules\adhocproject\controllers;

use app\models\Lead;
use app\models\Search\LeadSearch;
use Yii;
use yii\web\NotFoundHttpException;
use yii\helpers\ArrayHelper;
use app\models\Project;
use app\models\ProjectSearch;
use app\models\AwardedprojectSearch;
use app\models\QuotationMaster;
use app\models\QuotationSection;
use app\models\QuotationItems;
use app\models\Document;
use app\models\Drawing;
use app\controllers\BaseController;
/**
 * EquipmentGroupController implements the CRUD actions for EquipmentGroup model.
 */
class LeadController extends BaseController
{

    public function actionIndex()
    {

        $searchModel = new LeadSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        $dataProvider->pagination = ['PageSize' => 50];
        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

  
   public function actionDetailview()
    {
         $id = $_GET['id'];
        return $this->render('detail_view', [
            'model' => $this->findModel($id),
        ]);
    }

    public function actionCreate()
    {

        $model = new Lead();

        if ($model->load(Yii::$app->request->post())) {
  $request=Yii::$app->request->post();
  $model->lead_code=$request['Lead']['lead_code'];
  $model->lead_name=$request['Lead']['lead_name'];
  $model->lead_description=$request['Lead']['lead_description'];
  $model->lead_status_id=$request['Lead']['lead_status_id'];
  $model->lead_type_id=$request['Lead']['lead_type_id'];
  $model->first_name=$request['Lead']['first_name'];
  $model->last_name=$request['Lead']['last_name'];
  $model->phone=$request['Lead']['phone'];
  $model->mobile=$request['Lead']['mobile'];
  $model->fax=$request['Lead']['fax'];
$model->opportunity_amount=$request['Lead']['opportunity_amount'];


            $model->save();

                    if (!$model->save()) {
                        pr($model->getErrors());
                    }
           return $this->redirect(['index']);
          
        } else {

            return $this->renderAjax('create', [
                'model' => $model,

            ]);
        }
    }

    public function actionUpdate($id)
    {

        $model = $this->findModel($id);


        if ($model->load(Yii::$app->request->post())) {
            $postData=Yii::$app->request->post();

  $model->lead_code=$postData['Lead']['lead_code'];
  $model->lead_name=$postData['Lead']['lead_name'];
  $model->lead_description=$postData['Lead']['lead_description'];
  $model->lead_status_id=$postData['Lead']['lead_status_id'];
  $model->lead_type_id=$postData['Lead']['lead_type_id'];
  $model->first_name=$postData['Lead']['first_name'];
  $model->last_name=$postData['Lead']['last_name'];
  $model->phone=$postData['Lead']['phone'];
  $model->mobile=$postData['Lead']['mobile'];
  $model->fax=$postData['Lead']['fax'];
$model->opportunity_amount=$postData['Lead']['opportunity_amount'];

            if (!$model->save()) {
                pr($model->getErrors());
            }
           
     return $this->redirect(['index']);
          
        } else {
            return $this->renderAjax('update', [
                'model' => $model,
            ]);
        }
    }

    public function actionDeletes($id)
    {
       
        $this->findModel($id)->delete();
       return $this->redirect(['index']);
        
    }

    protected function findModel($id)
    {
        if (($model = Lead::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    

}

modules/adhocproject/controllers/QuotationController.php
<?php


namespace app\modules\adhocproject\controllers;


use Mpdf\Tag\P;
use Yii;
use yii\web\NotFoundHttpException;
use app\models\QuotationItems;
use app\models\QuotationMaster;
use app\models\QuotationSection;
use app\models\Customer;
use kartik\mpdf\Pdf;
use app\controllers\BaseController;


class QuotationController extends BaseController
{

    /**
     * Lists all QuotationMaster models.
     * @return mixed
     */
//    public function actionIndex() {
//     
//          $dataProvider = new ActiveDataProvider([
//               
//                'query' => QuotationMaster::find()  
//          ]);
//          
//            $dataProvider->pagination  = false;
//        
//            return $this->render('index', ['dataProvider' => $dataProvider,]);
// 
//    }
    /**
     * Displays a single QuotationMaster model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new QuotationMaster model.
     * If creation is successful, the browser will be redirected to the 'index' page.
     * @return mixed
     */
    public function actionCreate($id)
    {

        $quotationMaster = new QuotationMaster();
        $quotationsection = new QuotationSection();
        $quotationitems = new QuotationItems();
        $projectId = isset($_GET['id']) ? $_GET['id'] : "";
        $projectinfo = \app\models\AdhocProject::find()->where(['id' => $projectId])->asArray()->one();
        $clientId = $projectinfo['customer_id'];
        $getLastRecord = $quotationMaster->find()->orderBy(['id' => SORT_DESC])->asArray()->one();

        if (!empty($getLastRecord)) {
            $quotationId = $getLastRecord['id'] + 1;
        } else {
            $quotationId = 1;
        }

        $quotationNmuber = 'QUO' . '/' . $quotationId . '/' . 'CI' . '/' . date('Y');


        if ($quotationMaster->load(Yii::$app->request->post())) {


            $postData = Yii::$app->request->post();

            pr($postData);

            $quotationMaster->quotation_date = date('Y-m-d', strtotime($postData['QuotationMaster']['quotation_date']));
             $quotationMaster->name = $postData['QuotationMaster']['name'];
            $quotationMaster->project_id = $projectId;
            $quotationMaster->client_id = $clientId;
            $quotationMaster->quotation_number = $quotationNmuber;
            $sectionDatas = $postData['quotationsection'];
            if(!$quotationMaster->save()){
                pr($quotationMaster->getErrors());
            }

            echo $quotationMaster->id;
            die();
            $quotationmasterId = $quotationMaster->id;

            //pr($sectionDatas);

            foreach ($sectionDatas['items'] as $key => $sectItemsDatas) {

                $section = new QuotationSection();
                $section->quotation_master_id = $quotationmasterId;
                $section->section_name = $sectionDatas['section_name'][$key];
                $section->item_total_amount = $sectionDatas['item_total_amount'][$key];
                $section->multiple_item = $sectionDatas['multiple_item'][$key];

                if (!$section->save()) {
                    pr($section->getErrors());
                }

                $sectionItemsCount = (count($sectItemsDatas['description']));
                for ($i = 0; $i < $sectionItemsCount; $i++) {
                    $items = new QuotationItems();
                    $items->master_id = $quotationmasterId;
                    $items->section_id = $section->id;
                    $items->description = $sectItemsDatas['description'][$i];
                    $items->quantity = $sectItemsDatas['quantity'][$i];
                    $items->unit = $sectItemsDatas['unit'][$i];
                    $items->price = $sectItemsDatas['price'][$i];
                    $items->total_amount = $sectItemsDatas['total_amount'][$i];
                    $items->options = isset($sectItemsDatas['options'][$i]) ? $sectItemsDatas['options'][$i] : 0;
//                    isset($sectionDatas['options'][$i])?  $items->options = $sectionDatas['options'][$i]:$items->options=0;

                    if (!$items->save()) {
                        pr($items->getErrors());
                    }
                }
            }
            return Yii::$app->response->redirect(Yii::$app->request->referrer . "#quotation");
        } else {
            return $this->renderAjax('create', ['projectId' => $projectId, 'quotationMaster' => $quotationMaster, 'quotationsection' => $quotationsection, 'quotationitems' => $quotationitems]
            );
        }
    }


    public function actionCopyQuote()
    {

        $quoteId = $_REQUEST['id'];
        $quoteMaster = QuotationMaster::find()->where(['id' => $quoteId])->one();
        $cloneQuote = new QuotationMaster();
        $getLastRecord = QuotationMaster::find()->orderBy(['id' => SORT_DESC])->asArray()->one();
        if (!empty($getLastRecord)) {
            $quotationId = $getLastRecord['id'] + 1;
        } else {
            $quotationId = 1;
        }

        $quotationNmuber = 'QUO' . '/' . $quotationId . '/' . 'CI' . '/' . date('Y');
        foreach ($quoteMaster->attributes as $key => $val) {
            if ($key == 'quotation_number') {
                $cloneQuote->quotation_number = $quotationNmuber;
            } else {
                $cloneQuote->$key = $val;
            }

        }
        // $cloneQuote->attributes = $quoteMaster->attributes;
        $cloneQuote->isNewRecord = true;
        $cloneQuote->id = "";
        //pr($cloneQuote);
        $cloneQuote->save();
        $cloneMasterId = $cloneQuote->id;

        $quoteSection = QuotationSection::find()->where(['quotation_master_id' => $quoteId])->all();
        if (!empty($quoteSection)) {
            foreach ($quoteSection as $quoteSectionVal) {
                $qsecObj = new QuotationSection();
                $sectionId = $quoteSectionVal->id;
                foreach ($quoteSectionVal->attributes as $qkey => $qvalue) {
                    if ($qkey == 'quotation_master_id') {
                        $qsecObj->quotation_master_id = $cloneMasterId;
                    } else {
                        $qsecObj->$qkey = $qvalue;
                    }

                }
                $qsecObj->isNewRecord = true;
                $qsecObj->id = Null;
                $qsecObj->save();
                $clonesectionId = $qsecObj->id;

                $quoteItems = QuotationItems::find()->where(['master_id' => $quoteId, 'section_id' => $sectionId])->all();
                // pr($quoteItems);
                if (!empty($quoteItems)) {
                    foreach ($quoteItems as $quoteItemsVal) {
                        $qItemsObj = new QuotationItems();
                        foreach ($quoteItemsVal->attributes as $qkey => $qvalue) {
                            if ($qkey == 'master_id') {
                                $qItemsObj->master_id = $cloneMasterId;
                            } else if ($qkey == 'section_id') {
                                $qItemsObj->section_id = $clonesectionId;
                            } else {
                                $qItemsObj->$qkey = $qvalue;
                            }

                        }
                        $qItemsObj->isNewRecord = true;
                        $qItemsObj->id = Null;
                        $qItemsObj->save();

                    }

                }

            }
        }


        return Yii::$app->response->redirect(Yii::$app->request->referrer . "#quotation");


    }

    public function updateNew($postData)
    {
 // pr($postData);
        $quotationId = $postData['id'];
        $quotationMaster = new QuotationMaster();
        $projectId = isset($postData['project_id'])? $postData['project_id'] :"";
        $clientId = isset($postData['client_id'])? $postData['client_id'] :"";
        $count = QuotationMaster::find()->where(['parent_master' => $quotationId])->orderBy(['id' => SORT_DESC])->count();
        if (empty($count)) {
            $version = 1;
        } else {
            $version = $count + 1;
        }
        $quotationNmuber = 'QUO' . '/' . $quotationId . "-" . $version . '/' . 'CI' . '/' . date('Y');


        $quotationMaster->quotation_date = date('Y-m-d', strtotime($postData['QuotationMaster']['quotation_date']));
         $quotationMaster->name = $postData['QuotationMaster']['name'];
        $quotationMaster->project_id = $projectId;
        $quotationMaster->client_id = $clientId;
        $quotationMaster->quotation_number = $quotationNmuber;
        $quotationMaster->parent_master = $quotationId;
        $quotationMaster->version_id = $version;
        $quotationMaster->description = $postData['QuotationMaster']['description'];
        $quotationMaster->exclusion_text = $postData['QuotationMaster']['exclusion_text'];
        $quotationMaster->completion_period = $postData['QuotationMaster']['completion_period'];
        $quotationMaster->notes = $postData['QuotationMaster']['notes'];
        $quotationMaster->payment_terms = $postData['QuotationMaster']['payment_terms'];
        $quotationMaster->validity = $postData['QuotationMaster']['validity'];
        $quotationMaster->price = $postData['QuotationMaster']['price'];
        $quotationMaster->signature = $postData['QuotationMaster']['signature'];
        $quotationMaster->subtotal = $postData['QuotationMaster']['subtotal'];
        $quotationMaster->discount_rate = $postData['QuotationMaster']['discount_rate'];
        $quotationMaster->discount_amount = $postData['QuotationMaster']['discount_amount'];
        $quotationMaster->total_amount = $postData['QuotationMaster']['total_amount'];
      //  pr($quotationMaster);

        $sectionDatas = isset($postData['quotationsection'])? $postData['quotationsection'] :"";

modules/adhocproject/views/quotation/create.php
<?php

use yii\helpers\Html;
use yii\helpers\ArrayHelper;

/* @var $this yii\web\View */
/* @var $model app\models\PreventiveMaintenance */

$this->title = 'Quotation';
//$this->params['breadcrumbs'][] = ['label' => 'Customer', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
$this->params['title_icon'] = 'fa fa-file-code-o';


?>
<div class="customer-create">



    <?= $this->render('_form', [
        'projectId'=> $projectId ,
        'quotationMaster' => $quotationMaster, 
        'quotationsection' => $quotationsection, 
        'quotationitems' => $quotationitems
        
        
    ]) ?>

</div>

modules/adhocproject/views/quotation/index.php
<?php

use yii\helpers\Html;
use yii\bootstrap\Modal;
use kartik\grid\GridView;
use yii\helpers\Url;
use kartik\widgets\ActiveForm;
use kartik\builder\Form;
use kartik\builder\FormGrid;
use yii\web\View;


$id=$_GET['id']; 
Modal::begin([
        'header' => '<h4>Add Quotation</h4>',
        'id' => 'quote',
        'size' => 'modal-lg',
        'clientOptions' => ['backdrop' => 'static', 'keyboard' => FALSE]
    ]);

    echo "<div id ='modalquote'><div class='loader'></div></div>";
    Modal::end();
  
?>
<?php
            
    Modal::begin([
        'header' => '<h4>Edit BOQ</h4>',
        'id' => 'updateboq',
        'size' => 'modal-lg',
        'clientOptions' => ['backdrop' => 'static', 'keyboard' => FALSE]
    ]);

    echo "<div id ='modalupdateboq'><div class='loader'></div></div>";
    Modal::end();
    ?>
<div class="row">
                   <div class="col-md-12" >

                        <p class="text-right" >
                            <?=
                            Html::a(Yii::t('app', ' {modelClass}', [
                                        'modelClass' => 'Add Quotation',
                                    ]), ['quotation/create', 'id' => $model->id], ['class' => 'btn btn-success', 'id' => 'modalQuotes']);
                            ?>  </p>   
                    </div>
 <legend class="text-info"><small>Quotation</small></legend>
</div>

  
<?php
 yii\widgets\Pjax::begin();
if ($dataProvider) {
// pr($qsearchModel);
echo GridView::widget([
        'filterModel' => $qsearchModel,
        'dataProvider' => $dataProvider,
        'responsiveWrap' =>false,
        'columns' => [
            ['class' => 'kartik\grid\SerialColumn', 'mergeHeader' => false,],
         [
             'attribute' => 'quotation_number',
             'header' => '<div style="width:120px;">#NO.</div>',
            'value' => function($model, $key, $index) {
                return $model->quotation_number;
            },
            'vAlign' => 'middle',
            'format' => 'raw',
            'width' => '50px',
            //'noWrap' => true
        ],   
        [
             'attribute' => 'quotation_date',
            'header' => '<div style="width:120px;">Date</div>',
            'value' => function($model, $key, $index) {
                return Yii::$app->formatter->asDate($model->quotation_date, 'php:d-m-Y');
            },
            'vAlign' => 'middle',
            'format' => 'raw',
            'width' => '50px',
            //'noWrap' => true
        ],
         [
             'attribute' => 'name',
            'header' => '<div style="width:180px;">Name</div>',
            'value' => function($model, $key, $index) {
                 return $model->name;
            },
            'vAlign' => 'middle',
            'format' => 'raw',
            'width' => '50px',
            //'noWrap' => true
        ],
        [
            'attribute' => 'discount_amount',
            'header' => '<div style="width:180px;">Discount Amount</div>',
            'value' => function($model, $key, $index) {
               $discount= isset($model->discount_amount)?($model->discount_amount):'-';
               return number_format((float)$discount, 2, '.', ',');
                        
            },
            'vAlign' => 'middle',
            'format' => 'raw',
            'width' => '30px',
            //'noWrap' => true
        ],
        
        [
            'attribute' => 'total_amount',
            'header' => '<div style="width:100px;">Amount</div>',
            'value' => function($model, $key, $index) {
               return number_format((float)$model->total_amount, 2, '.', ',');
                        
            },
            'vAlign' => 'middle',
            'format' => 'raw',
            'width' => '10px',
            //'noWrap' => true
        ],
        
         
   [

  'class' => 'yii\grid\ActionColumn',
    'contentOptions' => ['style' => 'width:100px;text-align:center;','class'=>'skip-export'],
    'headerOptions' =>['class'=>'skip-export',],
     'header' => '<div style="width:80px;">Actions</div>',
    'template' => '{export-pdf}{detailview}{update}{deletes}{copy-quote}',
    'buttons' => [
                        'update' => function ($url, $model, $key) {
                           
                                return Html::a('<span class="glyphicon glyphicon-edit icons"></span>', Url::to(['quotation/update', 'id' => $model->id]),
                                    [
                                        'class'=>'updateboqs',
                                       'title' => Yii::t('app', 'Edit'),
                                       // 'data-pjax' => '0',
                                        
                                    ]
                                );
                            
                        },
                        'export-pdf' => function ($url, $model, $key) {
                                return Html::a('&nbsp;<span class="glyphicon glyphicon-print icons"></span>', Url::to(['quotation/export-pdf', 'id' => $model->id]),
                            
                              
                                    [
                                        'title' => Yii::t('app', 'Export'),
                                        'data-pjax' => '0',
                                        
                                    ]
                                );
                            
                        },
                        'copy-quote' => function($url,$model) {
                            return Html::a('&nbsp;<span class="fa fa-copy"></span>', Url::to(['quotation/copy-quote', 'id' => $model->id])
                            );
                        },
                        
                        'deletes' => function ($url, $model, $key) {
                           
                                return Html::a('&nbsp;<span class="glyphicon glyphicon-trash icons"></span>', Url::to(['quotation/deletes', 'id' => $model->id]),
                                    [
                                        'title' => Yii::t('app', 'Delete'),
                                        'data-pjax' => '0','data' => ['confirm' => 'Are you sure want to delete?'],
                                        
                                    ]
                                );
                            
                        },
                    ]
],
    ],

 // check the configuration for grid columns by clicking button above
  
         'pjax'=>false
      
]);
    
   
}

yii\widgets\pjax::end();
?>  

<?php
$this->registerJs("$(function() {
   $('#modalQuotes').click(function(e) {
     e.preventDefault();
     $('#quote').modal('show').find('#modalquote')
     .load($(this).attr('href'));
   });
});");
?>


<?= $this->registerJs(

  "$(document).on('ready pjax:success', function() {  // 'pjax:success' use if you have used pjax
    $('.updateboqs').click(function(e){
       e.preventDefault();      
       $('#updateboq').modal('show')
                  .find('#modalupdateboq')
                  .load($(this).attr('href'));  
   });
});
", View::POS_READY);